//----------------------------------------------------------------------------
//  Project TCPDUMP Filter
//
//  Copyright  1999. All Rights Reserved.
//
// SUBSYSTEM:           TCPDUMP Filter Application
// FILE:                tcpdfilter.cpp
// AUTHOR:              Trenton D. Adams
// PLATFORM:            Windows 98 [Version 4.10.2222]
// COMPILER:            Borland C++ v5.02/GCC for Linux
//
//----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int stringConvert(char string[255], char retString[255]);

void main(void)
{
   char tempString[255], tempString2[5], tempString3[5], tempString4[5],
        tempString5[5], tempString6[5], tempString7[5], tempString8[5],
        tempString9[5], retString[3];

   while (fgets(tempString, sizeof(tempString), stdin) != NULL)
   {  // begin while
	   if ((tempString[0] == '\t') && (tempString[1] == '\t') && (tempString[2] == '\t'))
	   {
         // tcpdump -x uses three tabs a space, and then the hex values
		   sscanf(tempString, "\t\t\t %s %s %s %s %s %s %s %s",
		          &tempString2, &tempString3,
		          &tempString4, &tempString5,
		          &tempString6, &tempString7,
		          &tempString8, &tempString9);
         // convert each hex string into two ASCII characters
	      stringConvert(tempString2, retString);
	      printf ("%s", retString);
	      stringConvert(tempString3, retString);
	      printf ("%s", retString);
	      stringConvert(tempString4, retString);
	      printf ("%s", retString);
	      stringConvert(tempString5, retString);
	      printf ("%s", retString);
	      stringConvert(tempString6, retString);
	      printf ("%s", retString);
	      stringConvert(tempString7, retString);
	      printf ("%s", retString);
	      stringConvert(tempString8, retString);
	      printf ("%s", retString);
	      stringConvert(tempString9, retString);
	      printf ("%s", retString);

         // get rid of the tabs and put spaces in
         tempString[0] = 32;
         tempString[1] = 32;
         tempString[2] = ':';
         printf ("%s", tempString);

         for(int x = 0;x < 5; x++)
         {
            tempString[x]  = 48;
            tempString2[x] = 48;
            tempString3[x] = 48;
            tempString4[x] = 48;
            tempString5[x] = 48;
            tempString6[x] = 48;
            tempString7[x] = 48;
            tempString8[x] = 48;
            tempString9[x] = 48;
         }
	   }
	   else
	   {
	      printf ("\n\n%s\n", tempString);
	   }
   } // End While
}

int stringConvert(char string[5], char retString[3])
{
/* Function:   Converts two bytes of HEX (ADFB) to two bytes of ASCII
   Input:      string with the HEX bytes and a NULL character
               retString buffer for the return string with two ASCII
               characters and a NULL
   Output:     none
   Return:     errorCode = 0 = no errors
               errorCode = 1 = errors with input string

   ALGORITHM
      Take apart the two bytes (actually four) of hex values and stick
      them in two separate null terminated strings
         sscanf each string for hex values
         put returned ASCII character in proper position of retString
         repeat step for next string
*/
   int character;

   char hex1[3];
   char hex2[3];

   hex1[0] = string[0];
   hex1[1] = string[1];
   hex1[2] = 0;

   hex2[0] = string[2];
   hex2[1] = string[3];
   hex2[2] = 0;

   sscanf (hex1, "%x", &character);
   if ((character >= 32) && (character < 127))
      retString[0] = (char)character;
   else
      retString[0] = 46;

   sscanf ( hex2, "%x", &character);
   if ((character >= 32) && (character < 127))
      retString[1] = (char)character;
   else
      retString[1] = 46;

   retString[2] = 0;

   return (0);
}
